//----------------------------------------------------
// funnelcube game source
//----------------------------------------------------
//   Marshall H
//   Retroactive
//
//   5/19/07 - 11/10/07
//----------------------------------------------------
//   Code is somewhat buggy. Hope you can learn from
//   it!
// ---------------------------------------------------


// Use F3DEX micrcode
#define  F3DEX_GBI

// Include all the N64 stuff
#include <ultra64.h>

// Include stuff
#include "include/config.h"
#include "include/helpfunc.h"
#include "include/types.h"


#include "graphics.h"
#include "sprite.h"
#include "hardware.h"
#include "control.h"



// Declare objects //
simpleObj	camera;
vec3_t		camera_dest;
vec3_t		camera_pdest;
float		camera_lag = 20;
float		move_lag = 5;

// playing grid
#define		FIELD_SIZE	9
#define		MAX_EXPLODE 10
#define		MAX_GLOB 16

cubeObj		cube[FIELD_SIZE][FIELD_SIZE];

simpleObj	bars;
simpleObj	shade;
selectObj	select;

simpleObj	bg;

simpleObj	clock;

explodeObj	explode[MAX_EXPLODE];
globObj		glob[MAX_GLOB];




// Misc constants
#define		PI		3.141592654
#define		DEG90	PI/2
#define		DEG180	PI


// Function prototypes
void renderObj(Gfx *displayList, vec3_t *pos, vec3_t *rot, float size, Gfx **listEnd);

void explosion(vec3_t posVec, float scale);
void makeGlob(vec3_t posVec2);
void drawExplosions(Gfx **DL_Pos);



//void drawExplosions(Gfx **DL_Pos);

//void renderCloud(cloud4Obj co, Gfx **DL_Pos);
//void makeCloud(cloud4Obj *co, float x, float y, float z, float size);


//void setCamera(float px, float py, float pz, float dx, float dy, float dz);
//void interpCamera(float px, float py, float pz, float dx, float dy, float dz, int start, int end, int pos);
//void interpCameraPos(float px, float py, float pz, int start, int end, int pos);

// Macros
#define VectorCopy(A,B) B[0]=A[0]; B[1]=A[1]; B[2]=A[2];
#define VectorScale(A,B,C) C[0]=A[0]*(B); C[1]=A[1]*(B); C[2]=A[2]*(B);
#define VectorAdd(A,B,C) C[0]=A[0]+B[0]; C[1]=A[1]+B[1]; C[2]=A[2]+B[2];
#define	setVec(V,X,Y,Z) V[0] = X; V[1] = Y; V[2] = Z;


void    boot(void *arg)
{
 void MainProc(void*);
 register int i;

    // Init OS //
    osInitialize();
  
    // Screen off //
    osViBlack(TRUE) ;

    // Create main thread //
    osCreateThread(&mainThread, MAIN_ID, MainProc, arg,
         (void *)(mainStack+STACKSIZE/8), (OSPri) MAIN_PRIORITY);

    // Start main thread //
    osStartThread(&mainThread);
} 






void    InitGlobalVars()
{
    // Init RSP Addresses //
    rsp_static_len  = _rsp_staticSegmentRomEnd - _rsp_staticSegmentRomStart;
    rsp_static_addr = (char *) _codeSegmentEnd;
    rsp_static_end  = (char *) _codeSegmentEnd + rsp_static_len;

    fifosize = (u8*)fifobuffer + (sizeof(u64) * FIFOSIZE) + 1;
}





void    MainProc(void *arg)
{
	void GameProc(void*);

    // Init some globals //
    InitGlobalVars() ;

    // Create game thread //
    osCreateThread(&gameThread, GAME_ID, GameProc, arg,
         (void *)(gameStack+STACKSIZE/8), GAME_PRIORITY);

    // Create video manager //
    osCreateViManager(OS_PRIORITY_VIMGR);

    // Set video mode //

    osViSetMode(&osViModeTable[SCREEN_MODE]);
    osViSetSpecialFeatures(OS_VI_DITHER_FILTER_OFF | OS_VI_GAMMA_OFF);

    // Create PI manager //
    osCreatePiManager((OSPri) OS_PRIORITY_PIMGR, &PiMessageQ, PiMessages,
            PI_MSGQUEUE_SIZE);

	

    // Start game thread //
    osStartThread(&gameThread);

    // Relinquish CPU //
    osSetThreadPri(NULL, 0);

    for(;;);
}






void GameProc(void *arg)
{
	void GameLoop();
	OSIoMesg dmaMb;    
	Gfx *l;

	// Create DMA message queue //
    osCreateMesgQueue(&DMAMessageQ, DMAMessages, DMA_MSGQUEUE_SIZE);

    // Create RSP message queue //
    osCreateMesgQueue(&RSPDoneMessageQ, RSPDoneMessages,
                RSPDONE_MSGQUEUE_SIZE);
    osSetEventMesg(OS_EVENT_SP, &RSPDoneMessageQ, dummyMsg);

    // Create RDP message queue //
    osCreateMesgQueue(&RDPDoneMessageQ, RDPDoneMessages,
                RDPDONE_MSGQUEUE_SIZE);
    osSetEventMesg(OS_EVENT_DP, &RDPDoneMessageQ, dummyMsg);

    // Create VRT message queue //
    osCreateMesgQueue(&RetraceMessageQ, RetraceMessages,
                RETRACE_MSGQUEUE_SIZE);
    osViSetEvent(&RetraceMessageQ, dummyMsg, 1);


	// SI (controllers)
	osCreateMesgQueue(&SiMessageQ, &SiMessages, 1);
    osSetEventMesg(OS_EVENT_SI, &SiMessageQ, (OSMesg)1);        




	initControllers();
    GameLoop();
} 




Dynamic         *generate;      // Dynamic info we're generating now
int             entity = 0;       // Current object

// graphics variables
int		firstframe = 1; // first frame
Gfx		*gdl_start;     // Start of this frame's dynamic display list */
Gfx		*gdl_end;       // Current position in dynamic display list
OSTask	*gentask;       // Task we're generating
u16		pnorm;          // perpsective norm variable

// controller variables
int		analogX = 0;
int		analogY = 0;
int		button[4];
OSContPad	**pad;
int		lockCamera = 0;


char	tempStr[64];

int		i;              // gen purpose
int		j;
int		k;
int		l;
int		dist;
int		x;
int		y;

int		lastx = 0;
int		lasty = 0;


// effect variables
int		fade_trans = 0;



int		loopStart = 0;
int		loopEnd = 0;
int		loopTime = 0;
float	speed = 1;

double	count = 0;
float	sineCount = 0;

float	xAccum = 0;
float	yAccum = 0;

float	cursorX = 0;
float	cursorY = 0;

int		swapping = 0;
float	swapCount = 0;

int		moving   [FIELD_SIZE][FIELD_SIZE];
float	moveCount[FIELD_SIZE][FIELD_SIZE];
int		scooting = 0;

float	fillCount = 0;

int		score = 0;

float	angle1;
float	angle2;

// custom vars
float	customVar1 = 0;

float interp;

// BG manipulation
int	r1, r2;
int	g1, g2;
int	b1, b2;
int	color1, color2;
int current_bg = 2;

void loop1()
{
	// Run task we built during the previous frame //
		if(!firstframe)
			osSpTaskStart(gentask);

		loopStart = (int)osGetTime() / 2100; //OS_CYCLES_TO_USEC(osGetTime());


		// Point to new dynamic buffer //
		generate = &(dynamic[CFB_NextCount]);

		// Reset entity counter (matrix and rotation object counter)
		entity = 0;

		// Set up pointers to GDL //
		gdl_start = generate->glist;
		gdl_end = gdl_start;

		// Init the GDL //
		N64initDL (&gdl_end, gdl_start, rsp_static_addr, generate,
					Next_CFB, YES, YES);


		checkCont();

		checkCamera();
}

void checkCont()
{

		// Read from the joypad controllers
		readController();        
		button[0]=controllerData[0].button;
		analogX=(int)(controllerData[0].stick_x);
        analogY=(int)(controllerData[0].stick_y);
		// deadzone
		if(fabs(analogX) < 10) {analogX = 0;}
		if(fabs(analogY) < 10) {analogY = 0;}

		if(analogX > 45) analogX = 45;
		if(analogX < -45) analogX = -45;
		if(analogY > 45) analogY = 45;
		if(analogY < -45) analogY = -45;

}

void checkCamera()
{

		/*
		if (button[0] & L_CBUTTONS) {camera.pos[0]+=cosf(camera.rot[1]-DEG90)*10;camera.pos[2]+=sinf(camera.rot[1]-DEG90)*10;}
		if (button[0] & R_CBUTTONS) {camera.pos[0]+=cosf(camera.rot[1]+DEG90)*10;camera.pos[2]+=sinf(camera.rot[1]+DEG90)*10;}
		if (button[0] & U_CBUTTONS) {camera.pos[0]+=cosf(camera.rot[1])*10;
									 camera.pos[1]+=sinf(camera.rot[0])*10;
									 camera.pos[2]+=sinf(camera.rot[1])*10;}
		if (button[0] & D_CBUTTONS) {camera.pos[0]+=cosf(camera.rot[1]+DEG180)*10;
									 camera.pos[1]+=sinf(camera.rot[0]+DEG180)*10;
									 camera.pos[2]+=sinf(camera.rot[1]+DEG180)*10;}

		*/

		// Camera interpolation
		camera.mov[0] += (camera.pos[0] - camera.mov[0]) / camera_lag;
		camera.mov[1] += (camera.pos[1] - camera.mov[1]) / camera_lag;
		camera.mov[2] += (camera.pos[2] - camera.mov[2]) / camera_lag;

		// interpolate the dest point as well
		camera_pdest[0] += (camera_dest[0] - camera_pdest[0]) / camera_lag;
		camera_pdest[1] += (camera_dest[1] - camera_pdest[1]) / camera_lag;
		camera_pdest[2] += (camera_dest[2] - camera_pdest[2]) / camera_lag;

		// Set up projection matrix //
		guPerspective(&(generate->proj), &pnorm, 59, 1.3333333, 100.0, 5000.0, 1.0);
		gSPPerspNormalize(gdl_end++, pnorm);

		guLookAt(&(generate->view),
					camera.mov[0]  , camera.mov[1]  , camera.mov[2] ,  // eye
					camera_pdest[0], camera_pdest[1], camera_pdest[2], // at
					1.0, 1.0, 0.0);						   // up

		gSPMatrix(gdl_end++, OS_K0_TO_PHYSICAL(&(generate->proj)),
					G_MTX_PROJECTION | G_MTX_LOAD | G_MTX_NOPUSH);
		gSPMatrix(gdl_end++, OS_K0_TO_PHYSICAL(&(generate->view)),
					G_MTX_PROJECTION | G_MTX_MUL | G_MTX_NOPUSH);
}


void drawSprites()
{
	// get ready to draw sprites

	    gDPPipeSync(gdl_end++);

		SpriteInit(&gdl_end);




		//if (button[0] & A_BUTTON) {fade_trans+=2;}
		//if (button[0] & B_BUTTON) {fade_trans-=2;}


		// messy blotches
		//for(i = 0; i < 120; i++)
		//{
		//	drawSprite(&gdl_end, &pic[i*320*2], 0+rand1(effect1_static)-effect1_static/2, i * 2, 320, 2, 1.0, 1.0, effect1_trans);
		//}

		// fade to black/white
		if(fade_trans != 0)
		{
			if(fade_trans > 0)
			{drawSprite(&gdl_end, &fade_white, 0, 0, 32, 32, 10, 7.5, fade_trans);			
			}else
			{drawSprite(&gdl_end, &fade_black, 0, 0, 32, 32, 10, 7.5, -fade_trans);
			}
		}
		drawString(&gdl_end, 0, 25, 30, "funnel", 0.6, 0.6, 128);
		drawString(&gdl_end, 0, 30, 39, "cube", 0.9, 0.9, 255);
		
		
		drawString(&gdl_end, 0, 26, 60, "by marshall/retroactive\n", 0.4, 0.4, 128);


		//sprintf(tempStr, "[%i, %i, %i]", (int)camera.pos[0], (int)camera.pos[1], (int)camera.pos[2]);
		//drawString(&gdl_end, 26, 130, "camera", 0.4, 0.4, 128);
		//drawString(&gdl_end, 26, 140, tempStr, 0.6, 0.6, 255);

		//sprintf(tempStr, "[%i, %i, %i]", (int)camera_dest[0], (int)camera_dest[1], (int)camera_dest[2]);
		//drawString(&gdl_end, 26, 170, "look-at", 0.4, 0.4, 128);
		//drawString(&gdl_end, 26, 180, tempStr, 0.6, 0.6, 255);		

		//sprintf(tempStr, "scooting = %i\nswapping = %i", scooting, swapping);
		//drawString(&gdl_end, 160, 40, tempStr, 0.5, 0.5, 255);		

		sprintf(tempStr, "score: %i", score);
		drawString(&gdl_end, 0, 30, 200, tempStr, 0.7, 0.7, 255);		

		SpriteFinish(&gdl_end);

}

void loop2()
{

		drawSprites();
	
	_gdlend:

		// End the GDL //
		N64terminateDL(&gdl_end);

		// Init task //
		gentask = &(task[CFB_NextCount]);
		N64initTask(gentask, gdl_end, gdl_start);

		// Flush cache //
		osWritebackDCacheAll();

		// Wait for previous task to finish //
		N64waitRSP(firstframe);
		N64waitRDP(firstframe);

	_alldone:
		
		// Swap buffers //
		N64swapCFB(firstframe);

		
		loopEnd = (int)osGetTime() / 2100 ; //OS_CYCLES_TO_USEC(osGetTime());

		loopTime = loopEnd - loopStart;

		speed = (float)loopTime / 100.0;

		// Wait for vertical retrace //
		N64waitVRT() ;

		firstframe = 0;

}

void GameLoop()
{
	camera.rot[1] = DEG180/2;
	camera.rot[0] = 0;


	camera.pos[0] = -100;
	camera.pos[1] = -100;
	camera.pos[2] = -1200;

	camera.mov[0] = -100;
	camera.mov[1] = -100;
	camera.mov[2] = -1200;

	VectorCopy(camera.pos, camera_dest);
	VectorCopy(camera.pos, camera_pdest);
	camera_dest[2] = 0;
	camera_pdest[2] = 0;




	setVec(bars.pos, 0, 0, 0);
	setVec(bars.rot, 0, 0, 270);

	setVec(shade.pos, -10, -30, 0);
	setVec(shade.rot, 0, 0, 270);
	
	setVec(select.pos, 0, 0, 0);
	setVec(select.rot, 0, 0, 270);

	setVec(clock.pos, -560, -50, 0);
	setVec(clock.rot, -8, 164, -45);

	initExplode();
	initGlob();
	initCubes();

	while (1)
	{

		loop1();

		// widescreen effect
		//gDPSetScissor(gdl_end++, G_SC_NON_INTERLACE, 0, 30, SCREEN_WIDTH, 210);



		if(button[0] & D_CBUTTONS)
		{
			//slow things down
			speed /= 4.0;
		}

		// get angle and magnitude of analog stick
		angle1 = atan2(analogY, analogX);
		angle2 = sqrtf(analogX * analogX + analogY * analogY)*0.75;


		// rotate angle 45 degrees, move invisible "cursor"
		if(swapping == 0)
		{
			cursorX -= cosf(angle1+0.25*PI) * angle2*(speed/8);
			cursorY += sinf(angle1+0.25*PI) * angle2*(speed/8);
		}


		if(cursorX < 0) cursorX = 0; 
		if(cursorY < 0) cursorY = 0; 

		camera_dest[0] = cursorX/8-130;
		camera_dest[1] = cursorY/8-130;
		camera.pos[2] = -600 - fillCount * 4;

		
		// match the selection box with "cursor"
		select.x = (int)(cursorX / 60);
		select.y = (int)(cursorY / 60);

		while(select.x + select.y > 6.5)
		{
			select.x --;
			select.y --;
 
			cursorX -= 60;
			cursorY -= 60;

			if(select.x < 0) select.x = 0; 
			if(select.y < 0) select.y = 0;
		}


		if(cursorX < 0) cursorX = 0; 
		if(cursorY < 0) cursorY = 0; 


		if(button[0] & A_BUTTON)
		{
			// rotate pieces under cursor
			if(swapping == 0 && scooting == 0)
			{
				// OK to swap

				swapping = 1;
				swapCount = 0;
			}
		}

		if(button[0] & B_BUTTON && scooting == 0)
		{
			for(y = 0; y < FIELD_SIZE; y++)
			{
				//for(x = 0; x < FIELD_SIZE; x++)
				//{

				if(cube[FIELD_SIZE-y-1][y].type < 0)
				{
					cube[FIELD_SIZE-y-1][y].type = rand1(5);
					explosion(cube[FIELD_SIZE-y-1][y].pos, 0.4);
				}
			}
					
		}

		if(swapping == 1)
		{
			swapCount += speed*1.5;
			cube[select.y][select.x].pos[0] += speed*1.5;
			cube[select.y][select.x+1].pos[1] += speed*1.5;
			cube[select.y+1][select.x+1].pos[0] -= speed*1.5;
			cube[select.y+1][select.x].pos[1] -= speed*1.5;

			if(swapCount > 60)
			{
				swapping = 0;

				// rotate cube types
				x = cube[select.y+1][select.x].type;
				cube[select.y+1][select.x].type = cube[select.y+1][select.x+1].type;
				cube[select.y+1][select.x+1].type = cube[select.y][select.x+1].type;
				cube[select.y][select.x+1].type = cube[select.y][select.x].type;
				cube[select.y][select.x].type = x;

				recalcCubes();

				
			}
		}
		
		
		
		

		// psychedelic bg

		for(y = 0; y < 32; y++)
		{
			for (x = 0; x < 17; x++)
			{
				

				// split up the color into individual color components.
				// format is 16-bit RGBA
				// 5551
				
				//color1 = Text_bg1_material01[y*32+x];
				//r1 = (color1 >> 11) & 0x1F ;
				//g1 = (color1 >> 6) & 0x1F ;
				//b1 = (color1 >> 1) & 0x1F ;

				
				switch(current_bg)
				{
				case 1:
					color2 = Text_bg1_material00[y*32+x];
					break;
				case 2:
					color2 = Text_bg2_material00[y*32+x];
					break;
				}


				r2 = (color2 >> 11) & 0x1F ;
				g2 = (color2 >> 6) & 0x1F ;
				b2 = (color2 >> 1) & 0x1F ;

			
				
				r1 = r2 + sinf(sineCount)*8;
				g1 = g2 + sinf(sineCount+PI/4)*8;
				b1 = b2 + sinf(sineCount-PI/4)*8;


				r1 /= 1.3;
				g1 /= 1.3;
				b1 /= 1.3;

				if(r1 > 31) r1 = 31;
				if(g1 > 31) g1 = 31;
				if(b1 > 31) b1 = 31;
				if(r1 < 0) r1 = 0;
				if(g1 < 0) g1 = 0;
				if(b1 < 0) b1 = 0;

				


				color2 = ((r1 << 11) & 0xf800)  | 
					     ((g1 << 6 ) & 0x7c0 )  |
						 ((b1 << 1 ) & 0x3e  );


				switch(current_bg)
				{
				case 1:
					Text_bg1_material01[y*32+x] = color2;
					break;
				case 2:
					Text_bg2_material01[y*32+x] = color2;
					break;
				}

				
			}
		}

		


		bg.rot[2] = 45;
		bg.mov[1] = -1900;
		bg.mov[0] = -1900;
		bg.mov[2] = 900;
		bg.rot[1] += speed/8;
		if(bg.rot[1] >= 360){bg.rot[1]-=360;}

		switch(current_bg)
		{
		case 1:
			renderObj(&Wtx_bg1_bg1_dl, bg.mov, bg.rot, 15, &gdl_end);
			break;
		case 2:
			renderObj(&Wtx_bg2_bg2_dl, bg.mov, bg.rot, 15, &gdl_end);
		}


		sineCount += (PI/360)*speed/10;
		if(sineCount > 8*PI) sineCount -= 8*PI;

		select.rot[2] = sinf(sineCount*32)*6;
		select.pos[0] = select.x * 60 - (60*FIELD_SIZE)/2+30;
		select.pos[1] = select.y * 60 - (60*FIELD_SIZE)/2+30;
		select.pos[2] = sinf(sineCount)*16+8;

		select.mov[0] += (select.pos[0] - select.mov[0]) / move_lag;
		select.mov[1] += (select.pos[1] - select.mov[1]) / move_lag;
		select.mov[2] = select.pos[2]; //+= (select.pos[2] - select.mov[2]) / move_lag;


		//gDPPipeSync(gdl_end++);
		//gDPSetRenderMode(gdl_end++, G_RM_OPA_SURF, G_RM_OPA_SURF2);

		renderObj(Wtx_select_select_dl, select.mov, select.rot, 0.75, &gdl_end);

		


		// sync, set new render mode (always call PipeSync before changing rendermodes
		gDPPipeSync(gdl_end++);
		gDPSetRenderMode(gdl_end++, G_RM_XLU_SURF, G_RM_XLU_SURF2);

		renderObj(Wtx_shade_shade_dl, shade.pos, shade.rot, 1, &gdl_end);
		renderObj(Wtx_bars_bars_dl, bars.pos, bars.rot, 1, &gdl_end);


		// count number of cubes
		fillCount = 0;
		for(y = 0; y < FIELD_SIZE; y ++)
		{
			for(x = 0; x < FIELD_SIZE-y-1; x++)
			{

				if(cube[y][x].type > 0)
				{
					fillCount ++;
				}
			}
		}
	

		// move down all cubes with air around them

		scooting = 0;
		
		if(swapping == 0)
		{
		for(y = 0; y < FIELD_SIZE; y ++)
		{
			for(x = 0; x < FIELD_SIZE-y-1; x++)
			{


				if(((cube[y][x].type <= 0) ) && moving[y][x] == 0)
				{
					// make sure a real block is above it
					if(cube[y][x+1].type > 0)
					{
						if(x == 0 || moving[y][x-1] == 0 )
						{
							moving[y][x] = 1;
							moveCount[y][x] = 0;
						}
						
					}
					else
					{
						cube[y][x].type = -2;
					}
				}

				
				if(moving[y][x] == 1)
				{
					scooting = 1;

					for(i = x + 1; i < FIELD_SIZE; i++)
					{
						cube[y][i].pos[0] -= speed*2;
					}
					
					moveCount[y][x]  += speed*2;

					if(moveCount[y][x] > 60){
						//done
						

						for(i = x + 1; i < FIELD_SIZE; i++)
						{
							cube[y][i].pos[0] += moveCount[y][x];
						}

						moving[y][x] = 0;						
						moveCount[y][x] = 0;

						for(i = x; i < FIELD_SIZE-1; i++)
						{
							cube[y][i].type = cube[y][i+1].type;
							
						}
						cube[y][FIELD_SIZE-1].type = -2;
						
					}
					break;
				}

			}
		}
		}


		if(scooting == 0 && swapping == 0){
		for(x = 0; x < FIELD_SIZE; x ++)
		{
			for(y = 0; y < FIELD_SIZE-x-1; y++)
			{
				if(((cube[y][x].type <= 0) ) && moving[y][x] == 0)
				{
					if(cube[y+1][x].type > 0)
					{
						// make sure a real block is above it
						if(y == 0 || moving[y-1][x] == 0 )
						{
							moving[y][x] = 2;
							moveCount[y][x] = 0;
						}
						
						
					}
					else
					{
						cube[y][x].type = -2;
					}
				}
				
				if(moving[y][x] == 2)
				{
					scooting = 1;
					for(i = y + 1; i < FIELD_SIZE; i++)
					{
						cube[i][x].pos[1] -= speed*2;
					}
					
					moveCount[y][x]  += speed*2;

					if(moveCount[y][x] > 60){
						//done
						

						for(i = y + 1; i < FIELD_SIZE; i++)
						{
							cube[i][x].pos[1] += moveCount[y][x];
						}

						moving[y][x] = 0;						
						moveCount[y][x] = 0;

						for(i = y; i < FIELD_SIZE-1; i++)
						{
							cube[i][x].type = cube[i+1][x].type;
							
						}
						cube[FIELD_SIZE-1][x].type = -2;
						
					}
					goto skipMoveBlock;
				}
				
			}
		}

		}

skipMoveBlock:
		// delete 4 contiguous cubes of the same type
		if(scooting == 0 && swapping == 0)
		{
		for(y = 0; y < FIELD_SIZE - 3 ; y ++)
		{
			for(x = 0; x < FIELD_SIZE - y - 3; x++)
			{
				
				i = cube[y][x].type;
				j = cube[y][x+1].type;
				k = cube[y][x+2].type;
				l = cube[y][x+3].type;
				
				if((i==j) && (j==k) && (i==k) && (k==l) && i > 0)
				{
					cube[y][x].type = -2;
					cube[y][x+1].type = -2;
					cube[y][x+2].type = -2;
					cube[y][x+3].type = -2;

					explosion(cube[y][x].pos, 0.4);
					explosion(cube[y][x+1].pos, 0.4);
					explosion(cube[y][x+2].pos, 0.4);
					explosion(cube[y][x+3].pos, 0.4);
					//score+=150;
					scooting = 1;
				}


				i = cube[y][x].type;
				j = cube[y+1][x].type;
				k = cube[y+2][x].type;
				l = cube[y+3][x].type;
				
				if((i==j) && (j==k) && (i==k) && (k==l) && i > 0)
				{
					cube[y][x].type = -2;
					cube[y+1][x].type = -2;
					cube[y+2][x].type = -2;
					cube[y+3][x].type = -2;

					explosion(cube[y][x].pos, 0.4);
					explosion(cube[y+1][x].pos, 0.4);
					explosion(cube[y+2][x].pos, 0.4);
					explosion(cube[y+3][x].pos, 0.4);
					//score+=150;
					scooting = 1;

					goto skipBlockCheck;
				}

			}
		}
		}


		// delete 3 contiguous cubes of the same type
		if(scooting == 0 && swapping == 0)
		{
		for(y = 0; y < FIELD_SIZE - 2 ; y ++)
		{
			for(x = 0; x < FIELD_SIZE - y - 2; x++)
			{
				
				i = cube[y][x].type;
				j = cube[y][x+1].type;
				k = cube[y][x+2].type;
				
				if((i==j) && (j==k) && (i==k) && i > 0)
				{
					cube[y][x].type = -2;
					cube[y][x+1].type = -2;
					cube[y][x+2].type = -2;

					explosion(cube[y][x].pos, 0.4);
					explosion(cube[y][x+1].pos, 0.4);
					explosion(cube[y][x+2].pos, 0.4);
					//score+=60;
					scooting = 1;
				}


				i = cube[y][x].type;
				j = cube[y+1][x].type;
				k = cube[y+2][x].type;
				
				if((i==j) && (j==k) && (i==k) && i > 0)
				{
					cube[y][x].type = -2;
					cube[y+1][x].type = -2;
					cube[y+2][x].type = -2;
					explosion(cube[y][x].pos, 0.4);
					explosion(cube[y+1][x].pos, 0.4);
					explosion(cube[y+2][x].pos, 0.4);
					//score+=60;
					scooting = 1;
					goto skipBlockCheck;
				}

			}
		}
		}


skipBlockCheck:


		// all cubes have the same white texture, tinted by vertex color. Save DMA time
		gDPLoadTextureBlock(gdl_end++, Text_cube1_material01, G_IM_FMT_RGBA, G_IM_SIZ_32b,
		32,32, 0, G_TX_WRAP|G_TX_NOMIRROR, G_TX_WRAP|G_TX_NOMIRROR,
		5,5, G_TX_NOLOD, G_TX_NOLOD);

		for(y = 0; y < FIELD_SIZE; y ++)
		{
			for(x = 0; x < FIELD_SIZE-y; x++)
			{
				cube[y][x].pos[2] = sinf(sineCount*16+((cube[y][x].pos[0]+cube[y][x].pos[1])/2)/60)*24;
				
				//if(cube[y][x].type != 0 )//&& !(x == FIELD_SIZE-1 && y == 0) && !(x == 0 && y == FIELD_SIZE-1) )
				if(y < 12)
				
				{
					switch(cube[y][x].type)
					{
					case 1:
						renderObj(Vtx_cube1_mesh01_dl, cube[y][x].pos, cube[y][x].rot, 0.5, &gdl_end);
						break;

					case 2:
						renderObj(Vtx_cube2_mesh01_dl, cube[y][x].pos, cube[y][x].rot, 0.5, &gdl_end);
						break;

					case 3:
						renderObj(Vtx_cube3_mesh01_dl, cube[y][x].pos, cube[y][x].rot, 0.5, &gdl_end);
						break;

					case 4:
						renderObj(Vtx_cube4_mesh01_dl, cube[y][x].pos, cube[y][x].rot, 0.5, &gdl_end);
						break;

					case 5:
						renderObj(Vtx_cube5_mesh01_dl, cube[y][x].pos, cube[y][x].rot, 0.5, &gdl_end);
						break;

					}

				}
			}
			
		}

		

		anim_glob_a_calc(0, 1, sinf(sineCount*16)/2+0.5);

		for(i = 0; i < MAX_GLOB; i++)
		{
			if(glob[i].sinCount >= 0)
			{

				// animation
				glob[i].sinCount += speed/30.0;
				if(glob[i].sinCount > 2*PI) glob[i].sinCount -= 2*PI;


				// slide the glob down the funnel
				/*
				glob[i].pos[0] -= speed;
				glob[i].pos[1] -= speed;
				
				{
				if(glob[i].pos[0] < -300) glob[i].pos[0] = -300;
				if(glob[i].pos[1] < -300) glob[i].pos[1] = -300;
				}
				else
				{
					if(glob[i].pos[0] < -400 || glob[i].pos[1] < -400) {glob[i].sinCount = -1;}
				}
				
				*/

				
				if(!(glob[i].pos[0] < -285 && glob[i].pos[1] < -285))
				{

					// hit bottom
					if(glob[i].pos[0] < -300) {
						glob[i].pos[0] = -300; 
						glob[i].dx = fabs(glob[i].dx)/1.3 + rand1(2)/4.0; 
						glob[i].dy /= speed/2             + rand1(2)/4.0; 
					}

					if(glob[i].pos[1] < -300) {
						glob[i].pos[1] = -300; 
						glob[i].dy = fabs(glob[i].dy)/1.3 + rand1(2)/4.0; 
						glob[i].dx /= speed/2             + rand1(2)/4.0; 
					}
				}
				else{
					if(glob[i].pos[0] < -420 || glob[i].pos[1] < -420) {
						glob[i].sinCount = -1;
						score += 50;
					}
				}

				glob[i].dx -= speed/15;
				glob[i].dy -= speed/15; 

				glob[i].pos[0] += glob[i].dx;
				glob[i].pos[1] += glob[i].dy;
				
				glob[i].rot[2] = sinf(glob[i].sinCount)*15;	
				
		
				renderObj(Wtx_glob1_glob1_dl, glob[i].pos, glob[i].rot, 0.15, &gdl_end);

				glob[i].pos[2] = -50;
				gDPPipeSync(gdl_end++);
			}

		}

		for(i = 0; i < MAX_EXPLODE; i++)
		{
			if(explode[i].expCount > 0)
			{
				//renderObj(Wtx_explode_explode_dl, explode[i].pos, explode[i].rot, explode[i].scale*sinf(explode[i].expCount * 0.02617993916*2)+0.05, &gdl_end);

				renderObj(Wtx_explode_explode_dl, explode[i].pos, explode[i].rot, explode[i].scale*sinf(explode[i].expCount * 0.02617993916*2)+0.05, &gdl_end);
				explode[i].expCount += speed;
				if(explode[i].expCount > 60)
				{
					explode[i].expCount = 0;
				}
			}

		}

		gDPPipeSync(gdl_end++);
		gDPSetRenderMode(gdl_end++, G_RM_ZB_OPA_SURF, G_RM_ZB_OPA_SURF2);
		
		// draw clock
		//renderObj(Wtx_clock_clock_dl, clock.pos, clock.rot, 0.7, &gdl_end);

		
		loop2();
    }

}

void initExplode()
{
	int i = 0;

	for(i = 0; i < MAX_EXPLODE; i++)
	{
		explode[i].expCount = 0;
		setVec(explode[i].rot, 0, 0, 270);
		setVec(explode[i].pos, 0, 0, 0);
	}
}

void initGlob()
{
	int i = 0;

	for(i = 0; i < MAX_GLOB; i++)
	{
		glob[i].sinCount = -1;
		setVec(glob[i].rot, 0, 0, 270);
		setVec(glob[i].pos, 0, 0, 100);
		glob[i].dx = -0.5;
		glob[i].dy = -0.5;
	}
}


void explosion(vec3_t posVec, float scale)
{
	

	int openExp = -1;
	int i = 0;

	makeGlob(posVec);

	// find an open explosion
	for(i = 0; i < MAX_EXPLODE; i++)
	{
		if(explode[i].expCount == 0)
		{
			openExp = i;
			break;
		}
	}

	if(openExp > -1)
	{

		

		VectorCopy(posVec, explode[i].pos);
		explode[i].expCount = 1;
		explode[i].scale = scale;


		
	}

	
}

void makeGlob(vec3_t posVec2)
{
	int openGlob = -1;
	int i = 0;

	// find an open explosion
	for(i = 0; i < MAX_GLOB; i++)
	{
		if(glob[i].sinCount == -1)
		{
			openGlob = i;
			break;
		}
	}

	if(openGlob > -1)
	{
		VectorCopy(posVec2, glob[i].pos);
		glob[i].sinCount = (float)rand1(30)/3.0;
		glob[i].dx = 2.0 + (10-rand1(10))/5.0;
		glob[i].dy = 2.0 + (10-rand1(10))/5.0;
	}
}

void initCubes()
{

	for(y = 0; y < FIELD_SIZE; y ++)
	{
		for(x = 0; x < FIELD_SIZE; x++)
		{
			setVec(cube[y][x].pos, x*60-(60*FIELD_SIZE)/2, y*60-(60*FIELD_SIZE)/2, 0);
			setVec(cube[y][x].rot, 0, 0, 270);
			cube[y][x].type = -2;
			moving[y][x] = 0;
			moveCount[y][x] = 0;
		}

		for(x = 0; x < (FIELD_SIZE-y); x++)
		{
		
			if(y < FIELD_SIZE)
				cube[y][x].type = rand1(5);
			
		}
	}

}

void recalcCubes()
{

	for(y = 0; y < FIELD_SIZE; y ++)
	{
		for(x = 0; x < FIELD_SIZE; x++)
		{
			setVec(cube[y][x].pos, x*60-(60*FIELD_SIZE)/2, y*60-(60*FIELD_SIZE)/2, 0);
			setVec(cube[y][x].rot, 0, 0, 270); 
		}
	}
}


void renderObj(Gfx *displayList, vec3_t *pos, vec3_t *rot, float size, Gfx **DL_Pos)
{
	// grab the DL
	Gfx     *glistp;
    glistp = *DL_Pos;


	// translate and rotate the object
	guPosition( &(generate->xform[entity]),
					270+(*rot)[0],	(*rot)[1],   (*rot)[2],       // rot
					size,								// scale                   
					(*pos)[0],		(*pos)[1]  , (*pos)[2]  );    // pos 

	gSPMatrix(glistp++, OS_K0_TO_PHYSICAL(&(generate->xform[entity])),
				   G_MTX_MODELVIEW | G_MTX_LOAD | G_MTX_NOPUSH);


		

	gSPDisplayList(glistp++, displayList);

	//gSPPopMatrix(glistp++, G_MTX_MODELVIEW);

	// give the DL back
	*DL_Pos     = glistp;

	entity++;

}





